include std/dll.e
include std/machine.e
include std/text.e
include std/get.e

constant thedll = open_dll("euconvert.dll"),
v3_define_c_func_ = define_c_func(thedll, "v3_define_c_func", {C_POINTER}, C_INT),
v3_define_c_proc_ = define_c_func(thedll, "v3_define_c_proc", {C_POINTER}, C_INT),
v3_c_func_ = define_c_func(thedll, "v3_c_func", {C_INT, C_POINTER}, C_POINTER),
v3_c_proc_ = define_c_proc(thedll, "v3_c_proc", {C_INT, C_POINTER}),
v3_free_ = define_c_proc(thedll, "v3_free", {C_POINTER})

if find(-1, {thedll, v3_define_c_func_, v3_define_c_proc_, v3_c_func_, v3_c_proc_, v3_free_} ) then
        puts(1, "thedll, v3_define_c_func_, v3_define_c_proc_, v3_c_func_, v3_c_proc_, v3_free_\n")
        ? {thedll, v3_define_c_func_, v3_define_c_proc_, v3_c_func_, v3_c_proc_, v3_free_}
	puts(1, "error opening one of the above\n")
	abort(1)
end if

public function v3_define_c_func(atom dll, sequence name, sequence args, atom ret)
	sequence all = {dll, name, args, ret}
	all = sprint(all)
	atom addr = allocate_string(all)
	integer r = c_func(v3_define_c_func_, {addr})
	free(addr)
	return r
end function

public function v3_define_c_proc(atom dll, sequence name, sequence args)
	sequence all = {dll, name, args}
	all = sprint(all)
	atom addr = allocate_string(all)
	integer r = c_func(v3_define_c_proc_, {addr})
	free(addr)
	return r
end function

public function v3_c_func(integer func, sequence args)
	sequence all = sprint(args)
	atom addr = allocate_string(all)
	atom ret = c_func(v3_c_func_, {func, addr})
	free(addr)
	all = peek_string(ret)
	-- since this was allocated by a v3 runtime, we need to make sure
	-- that it is freed by the same runtime that did the allocation
	c_proc(v3_free_, {ret})
	all = value(all)
	return all[2]
end function

public procedure v3_c_proc(integer func, sequence args)
	sequence all = sprint(args)
	atom addr = allocate_string(all)
	c_proc(v3_c_proc_, {func, addr})
	free(addr)
end procedure
